/* code emit. You know it is very similar to eval */

#include <setjmp.h>
jmp_buf topenv;

#include "ptopcode.h"
#include "opcode.h"

#include "vcc.h"
#include "vm.h"

#define binemit(op) {codemit(cstack[top].val1);codemit(cstack[top].val2);codepush(op);}
#define codepush(op) {codepush2(op, 0);}


int codepush2(int op, int operand)
{
  codeseg[codepc].op = op;
  codeseg[codepc].operand = operand;
  return codepc++;
}

#define LVARSTACKLEN 512

int lvarstack[LVARSTACKLEN];
int lvarp;
extern int codepc;
int savedcodepc;

int codemitinit()
{
  lvarp = 0;
  codepc = 0;
  savedcodepc = 0;
}


#define LABELSTACKLEN 16
#define JMPINSNSTACKLEN 32
#define DONTUSE (-1)

struct {
  int labname;
  int jumpb; /* for break */
  int jumpr; /* for redo */
} clabelstack[LABELSTACKLEN];


struct {
  int labelstackptr;
  int jmpinsn;
  int kind;
} jmpinsnstack[JMPINSNSTACKLEN];

static int clabelstacktop = -1;
static int jmpinsnstacktop = -1;
static int defaultclabelstackptr = -1;

int cdolabel(int labelname)
{
  clabelstack[++clabelstacktop].labname = labelname;
  defaultclabelstackptr = clabelstacktop;
  return clabelstacktop;
}

void crewindlabel()
{
  clabelstack[defaultclabelstackptr].labname = DONTUSE;
  while (defaultclabelstackptr>= 0) {
    if (clabelstack[--defaultclabelstackptr].labname != DONTUSE)
      break;
  }
}

int cfindlabel(int labelname)
{
  int i;
  if (labelname == 0) {
    return defaultclabelstackptr;
  } else {
    for (i = defaultclabelstackptr; i>=0; i--) {
      if (clabelstack[i].labname == labelname)
	return i;
    }
    /*     return defaultclabelstackptr; */

        {char msg[256];
      sprintf(msg, "%s: label out of scope", namepool+labelname);
      yyerror(msg);
      return -1;
    }


  }
}

void cdojmpset(int label, int top, int bot)
{
  if (label < 0) longjmp(topenv, -1);
  clabelstack[label].jumpb = bot;
  clabelstack[label].jumpr = top;
}

int jmpinsnreg(int pc, int kind, int jmpto)
{
  int label = cfindlabel(jmpto);

  if (label <0) longjmp(topenv, -1);
  jmpinsnstack[++jmpinsnstacktop].labelstackptr = label;
  jmpinsnstack[jmpinsnstacktop].jmpinsn = pc;
  jmpinsnstack[jmpinsnstacktop].kind = kind;
}

void jmpinsnresolv()
{
  int i, label;
  for (i = jmpinsnstacktop; i >=0; i--) {
    label = jmpinsnstack[i].labelstackptr;
    switch (jmpinsnstack[i].kind) {
    case BREAK:
      codeseg[jmpinsnstack[i].jmpinsn].operand = clabelstack[label].jumpb-jmpinsnstack[i].jmpinsn;
      break;
    case REDO:
      codeseg[jmpinsnstack[i].jmpinsn].operand = clabelstack[label].jumpr-jmpinsnstack[i].jmpinsn;
      break;
    }
  }
  jmpinsnstacktop = -1;
  clabelstacktop = -1;
  defaultclabelstackptr = -1;
}


int staticvarsearch(int varname)
{
  int i, j, paramlist, pos, res;

  if (lvarp == -1) {
    return -1;
  }
  for (i = 0, pos = 0, res = -1; i <= lvarp; i++, pos+= j) {
    paramlist = lvarstack[i];
    if (debug)
      printf("staticvarsearch: checking %d (%d)\n", paramlist, i);
    for (j = 0; cstack[paramlist].opcode == PARAM; j++, paramlist = cstack[paramlist].val2) {
      if (cstack[cstack[paramlist].val1].val1 == varname) {
	if (debug)
	  printf("staticvarsearch: local for %s (%d)\n", namepool+varname, pos+j);
	res = pos+j;
      }
    }
  }
  return res;
}


printemit()
{
  codepush(OP_PRINT_TOP);
}

codemit(int top)
{
  int res;
  int savedcalledtop;

  switch (cstack[top].opcode) {
  case LIT: 
    codepush2(OP_PUSH_CONST, cstack[top].val1);
    break;
  case VAR: 
    {int varpos = staticvarsearch(cstack[top].val1);

      if (varpos == -1) {
	codepush2(OP_PUSH_GVAR, cstack[top].val1);
      } else {
	codepush2(OP_PUSH_LVAR, varpos);
      }
      break;
    }
  case MOV:
    codemit(cstack[top].val2);
    codepush(OP_DUP); 	/* added on March 20, 2018 */
    codemitlhs(cstack[top].val1);
#if 0
    { 
      if (cstack[cstack[top].val1].opcode == VAR) {
	int varname = cstack[cstack[top].val1].val1;
	int varpos = staticvarsearch(varname);


	if (varpos == -1) { /* global var */
	  codepush2(OP_STORE_GVAR, varname);
	} else { /* local var */
	  codepush2(OP_STORE_LVAR, varpos);
	}
      } else if (cstack[cstack[top].val1].opcode == LISTREF) { /* list */
	codemitlistref(cstack[top].val1);
	codepush(OP_STORE_ADDR);
      } else if (cstack[cstack[top].val1].opcode == OBJREF) { /* object ref */
	codemitobjref(cstack[cstack[top].val1].val1);
	if (cstack[cstack[cstack[top].val1].val2].opcode == VAR) { /* simple field */
	  codepush2(OP_STORE_FIELD, cstack[cstack[cstack[top].val1].val2].val1);
	} else if (cstack[cstack[cstack[top].val1].val2].opcode == FUNCALL) { /* impossible */
	}
      }
      break;
    }
#endif
    break;
  case ADD: 
    binemit(OP_B_ADD);
    break;
  case SUB: 
    binemit(OP_B_SUB);
    break;
  case MUL: 
    binemit(OP_B_MUL);
    break;
  case GREATER:
    binemit(OP_B_GREATER);
    break;
  case GREATEREQ:
    binemit(OP_B_GREATEREQ);
    break;
  case LESSEQ:
    binemit(OP_B_LESSEQ);
    break;
  case LESS:
    binemit(OP_B_LESS);
    break;
  case EQUAL:
    binemit(OP_B_EQUAL);
    break;
  case NOTEQUAL:
    binemit(OP_B_NOTEQUAL);
    break;
  case IF:
    {int t1, t2, r1, r2;

      codemit(cstack[top].val1);
      t1 = codepush2(OP_JMPZ, 0);
      codemit(cstack[cstack[top].val2].val1);
      t2 = codepush2(OP_JMP, 0);
      r1 = codepc; codeseg[t1].operand = r1-t1;
      codemit(cstack[cstack[top].val2].val2);
      r2 = codepc; codeseg[t2].operand = r2-t2;
      break;
    }
  case COMPOUND:
    codemit(cstack[top].val1);
    /*     codepush2(OP_POP, 1); */ /* discard the result */
    codemit(cstack[top].val2);
    break;
  case WHILE:
    { int t1, t2, r1, r2, lab;
      lab = cdolabel(cstack[top].val1);

      r1 = codepc;
      codemit(cstack[cstack[top].val2].val1);
      t1 = codepush2(OP_JMPZ, 0);
      codemit(cstack[cstack[top].val2].val2);
      codepush2(OP_JMP, r1-codepc);
      r2 = codepc; codeseg[t1].operand = r2-t1;
      cdojmpset(lab, r1, r2);
      if (lab == 0) {
	jmpinsnresolv();
      } else {
	crewindlabel();
      }
      break;
    }
  case FUNCALL:
    { int alen;

      alen = codemitargs(cstack[top].val2);
      codepush2(OP_PUSH_CONST, alen);
      codepush2(OP_CALL, cstack[top].val1);
      break;
    }
  case FMOV:
    codemitargs(vars[cstack[top].val2].param);
    codemit(cstack[top].val2);
    savedcodepc = codepc;
    codepush2(OP_PUSH_GVAR, cstack[top].val1);
    /* 
    vars[cstack[top].val1].kind = FUN;
    vars[cstack[top].val1].val = cstack[top].val2;
    vars[cstack[top].val1].param = vars[cstack[top].val2].param;
    return (vars[cstack[top].val1].val);
    */
    break;
  case MYVAR:
    lvarstack[++lvarp] = cstack[top].val1;
    break;
  case LENV:
    {int savedlvarp;
      savedlvarp = lvarp;
      codemit(cstack[top].val1);
      lvarp = savedlvarp;
      break;
    }
  case NEG:
    codemit(cstack[top].val1);
    codepush(OP_U_NOT);
    break;
  case LISTDEF:
    codemit(cstack[top].val2);
    codepush(OP_DUP);
    { 
	int varname = cstack[cstack[top].val1].val1;
	int varpos = staticvarsearch(varname);

	if (varpos == -1) { /* global var */
	  codepush2(OP_STORE_GVAR, varname);
	} else { /* local var */
	  codepush2(OP_STORE_LVAR, varpos);
	}
    }
    break;
  case LISTA:
    codemitlistalloc(top);
    break;
  case LISTREF:
    codemitlistref(top);
    codepush(OP_PUSH_ADDR);
    break;
  case RET:
    codemit(cstack[top].val1);
    codepush(OP_RETURN);
    break;
  case BREAK:
    jmpinsnreg(codepush2(OP_JMP, 0), BREAK, cstack[top].val1);
    break;
  case REDO:
    jmpinsnreg(codepush2(OP_JMP, 0), REDO, cstack[top].val1);
    break;
  case NEWOBJ:
    codemitcreateobj(cstack[top].val2);
    codepush(OP_DUP);
    codemitlhs(cstack[top].val1);
    break;
  case THIS:
    codepush2(OP_PUSH_LVAR, 0); /* this must appear as the first argument */
    break;
  case OBJREF:
    codemitobjref(top);
    break;
  }
}

int globalvarsearch(int varname)
{
  ENTRY e, *r;
  e.key = namepool+varname;
  hsearch_r(e, FIND, &r, &varhash);
  if (r == NULL) {
    int j;

    j = varstop++;
    vars[j].kind = VAL;
    vars[j].name = varname;
    vars[j].val = 0;

    e.data = (void *)j;
    hsearch_r(e, ENTER, &r, &varhash);
    return j;
  } else {
    return (int)(r->data);
  }
}



funcodemit(int varname)
{
  int entry = codepc;
  int gv, vpos;
  /* only allow global definition */

  vpos = globalvarsearch(varname);

  lvarp = 0;
  lvarstack[lvarp] = vars[vpos].param;
  codemit(vars[vpos].val);
  codepush(OP_RETURN);
  /* final return */

  lvarp = -1;

  gv = vmglobalvarsearch(varname);

  objectab[gv].typ = FUN;
  objectab[gv].val = entry;
  objectab[gv].paramlen = vars[vpos].paramlen;
  savedcodepc = codepc; /* code segment goes ahead */
}

classcodemit(int cname)
{
  int gv, vpos;
  /* only allow global definition */
  vpos = globalvarsearch(cname);

  gv = vmglobalvarsearch(cname);

  objectab[gv].typ = CLS;
  objectab[gv].val = methoddef(vars[vpos].val, vars[vpos].paramlen);
  objectab[gv].paramlen = vars[vpos].paramlen;
  savedcodepc = codepc; /* code segment goes ahead */
}


int methoddef(int cbody, int size)
{
  int i;
  int x;

  x = listalloc2(methentrysize*size);

  for (i = 0; i < size; i++, cbody = cstack[cbody].val2) {
    int meth = cstack[cbody].val1;

    methname(x, i) = cstack[meth].val1;

    if (cstack[meth].opcode == VAR)  {
      methkind(x, i) = VAL;
    } else if (cstack[meth].opcode == FUNCALL)  { /* this must be FUNCALL */
      methkind(x, i) = FUN;
      methbody(x, i) = methodcodemit(cstack[cstack[meth].val2].val2, 
				   cstack[cstack[meth].val2].val1);
      methparamlen(x, i) = plistlen(cstack[cstack[meth].val2].val1);
      methresk(x, i) = VAL;
    }
  }
  return x;
}

methodcodemit(int mbody, int param)
{
  int entry = codepc;
  int gv, vpos;

  lvarp = 0;
  lvarstack[lvarp] = param;
  codemit(mbody);
  codepush(OP_RETURN);
  /* final return */

  lvarp = -1;

  savedcodepc = codepc; /* code segment goes ahead */
  return entry;
}

codemitargs(int arglist)
{
  int i;
  for (i = 0;cstack[arglist].opcode == ARG; i++, arglist = cstack[arglist].val2) {
    codemit(cstack[arglist].val1);
  }
  return i;
}

extern int listkeywordpos;

codemitlistalloc(int al)
{
  int i=0;

  for (i = 0; cstack[al].opcode == LISTA; al = cstack[al].val2, i++) {
    codemit(cstack[al].val1);
  }
  codepush2(OP_PUSH_CONST, i);
  codepush2(OP_CALL, listkeywordpos);
}

codemitlistref(int lref)
{
  if (cstack[cstack[lref].val1].opcode == VAR) {
    int varname = cstack[cstack[lref].val1].val1;
    int varpos = staticvarsearch(varname);

    if (varpos == -1) { /* global var */
      codepush2(OP_PUSH_GVAR, varname);
    } else { /* local var */
      codepush2(OP_PUSH_LVAR, varpos);
    }
  } else {
    codemitlistref(cstack[lref].val1);
    codepush(OP_PUSH_ADDR);
  }
  codemit(cstack[lref].val2);
  codepush(OP_B_ADD);
}

codemitlistrefmeth(int lref)
{
  if (cstack[cstack[lref].val1].opcode == VAR) {
    codepush2(OP_PUSH_FIELD, cstack[cstack[lref].val1].val1);
  } else {
    codemitlistrefmeth(cstack[lref].val1);
    codepush(OP_PUSH_ADDR);
  }
  codemit(cstack[lref].val2);
  codepush(OP_B_ADD);
}

codemitcreateobj(int ol)
{
  int i, inimethod;

  codepush2(OP_PUSH_CONST, cstack[ol].val1);
  codepush2(OP_PUSH_CONST, 1);
  codepush2(OP_CALL, newpos());

  /* if initialization is specified. */
  inimethod = clsmethodsearch(cstack[ol].val1, initpos());

  if (inimethod >=0) {
    codepush(OP_DUP);
    i = codemitargs(cstack[cstack[ol].val2].val2);
    codepush2(OP_PUSH_CONST, i+1);
    codepush2(OP_DUP2, i+1);
    codepush2(OP_PUSH_FIELD, initpos());
    codepush(OP_CALL2);
    codepush2(OP_POP, 1); /* discard the result */
  }
}

codemitobjref(int oref)
{
  int alen;

  if (cstack[oref].opcode == VAR) {
    int varname = cstack[oref].val1;
    int varpos = staticvarsearch(varname);

    if (varpos == -1) { /* global var */
      codepush2(OP_PUSH_GVAR, varname);
    } else { /* local var */
      codepush2(OP_PUSH_LVAR, varpos);
    }
    return;
  }
  if (cstack[cstack[oref].val1].opcode == VAR) {
    int varname = cstack[cstack[oref].val1].val1;
    int varpos = staticvarsearch(varname);

    if (varpos == -1) { /* global var */
      codepush2(OP_PUSH_GVAR, varname);
    } else { /* local var */
      codepush2(OP_PUSH_LVAR, varpos);
    }
  } else {
    codemitobjref(cstack[oref].val1);
  }
  if (cstack[cstack[oref].val2].opcode == VAR) {
    codepush2(OP_PUSH_FIELD, cstack[cstack[oref].val2].val1);
  } else if (cstack[cstack[oref].val2].opcode == FUNCALL) {
    /*    codepush(OP_DUP); */ /* push this */
    alen = codemitargs(cstack[cstack[cstack[oref].val2].val2].val2);
    codepush2(OP_PUSH_CONST, alen+1);
    codepush2(OP_DUP2, alen+1);
    codepush2(OP_PUSH_FIELD, cstack[cstack[oref].val2].val1);
    codepush(OP_CALL2);
  } else if (cstack[cstack[oref].val2].opcode == LISTREF) {
    codemitlistrefmeth(cstack[oref].val2);
    codepush(OP_PUSH_ADDR);
  }
}

codemitlhs(int lhs)
{ 

  if (cstack[lhs].opcode == VAR) {
    int varname = cstack[lhs].val1;
    int varpos = staticvarsearch(varname);

    if (varpos == -1) { /* global var */
      codepush2(OP_STORE_GVAR, varname);
    } else { /* local var */
      codepush2(OP_STORE_LVAR, varpos);
    }
  } else if (cstack[lhs].opcode == LISTREF) { /* list */
    codemitlistref(lhs);
    codepush(OP_STORE_ADDR);
  } else if (cstack[lhs].opcode == OBJREF) { /* object ref */
    codemitobjref(cstack[lhs].val1);
    if (cstack[cstack[lhs].val2].opcode == VAR) { /* simple field */
      codepush2(OP_STORE_FIELD, cstack[cstack[lhs].val2].val1);
    } else if (cstack[cstack[lhs].val2].opcode == FUNCALL) { /* impossible */
    } else if (cstack[cstack[lhs].val2].opcode == LISTREF) {
      codemitlistrefmeth(cstack[lhs].val2);
      codepush(OP_STORE_ADDR);
    }
  }
}


#include "mnemonic.c"


disassemble()
{
  int i;

  for (i = 0; i < codepc; i++) {
    if (codeseg[i].op < OP_JMP || codeseg[i].op == OP_RETURN) {
      /* with no operand */
      if (codeseg[i].op == OP_DUP2 || codeseg[i].op == OP_POP) 
	printf("%s %d\n", mnemonic[codeseg[i].op], codeseg[i].operand);
      else
	printf("%s\n", mnemonic[codeseg[i].op]);
    } else if (codeseg[i].op == OP_PUSH_GVAR || codeseg[i].op == OP_STORE_GVAR || codeseg[i].op == OP_PUSH_FIELD || codeseg[i].op == OP_STORE_FIELD || codeseg[i].op == OP_CALL) {
      printf("%s %s\n", mnemonic[codeseg[i].op], namepool+codeseg[i].operand);
    } else if (codeseg[i].op < OP_RETURN) {
      printf("%s %d\n", mnemonic[codeseg[i].op], codeseg[i].operand);
    } 
  }
}


