#include "ptopcode.h"
#include "vcc.h"

codeprint()
{
  int i;

  for (i = cstacktop-1; i >=0; i--) {
    switch (cstack[i].opcode) {
    case LIT: printf("(LIT %d)\n", cstack[i].val1); break;
    case ADD: printf("(ADD %d, %d)\n", cstack[i].val1, cstack[i].val2); break;
    case SUB: printf("(SUB %d, %d)\n", cstack[i].val1, cstack[i].val2); break;
    case MUL: printf("(MUL %d, %d)\n", cstack[i].val1, cstack[i].val2); break;
    case VAR: printf("(VAR %s)\n", namepool+cstack[i].val1); break;
    case MOV: printf("(MOV %d, %d)\n", cstack[i].val1, cstack[i].val2);break;
    case GREATEREQ: printf("(GE %d, %d)\n", cstack[i].val1, cstack[i].val2); break;
    case GREATER: printf("(GT %d, %d)\n", cstack[i].val1, cstack[i].val2); break;
    case LESSEQ: printf("(LE %d, %d)\n", cstack[i].val1, cstack[i].val2); break;
    case LESS: printf("(LT %d, %d)\n", cstack[i].val1, cstack[i].val2); break;
    case EQUAL: printf("(EQ %d, %d)\n", cstack[i].val1, cstack[i].val2); break;
    case NOTEQUAL: printf("(NE %d, %d)\n", cstack[i].val1, cstack[i].val2); break;
    case IF: printf("(IF %d, %d)\n", cstack[i].val1, cstack[i].val2); break;
    case ALT: printf("(ALT %d, %d)\n", cstack[i].val1, cstack[i].val2); break;
    case WHILE: printf("(WHILE %d, %d)\n", cstack[i].val1, cstack[i].val2); break;
    case COMPOUND: printf("(COMPOUND %d, %d)\n", cstack[i].val1, cstack[i].val2); break;
    case FMOV: printf("(FMOVE %d %d)\n", cstack[i].val1, cstack[i].val2); break;
    case FUNCALL: printf("(FUNCALL %s %d)\n", namepool+cstack[i].val1, cstack[i].val2); break;
    case PARAM:printf("(PARAM %d %d)\n", cstack[i].val1, cstack[i].val2); break;
    case ARG:printf("(ARG %d %d)\n", cstack[i].val1, cstack[i].val2); break;
    case MYVAR: printf("(MYVAR %d)\n", cstack[i].val1); break;
    case LENV: printf("(LENV %d)\n", cstack[i].val1); break;
    case NEG: printf("(NEG %d)\n", cstack[i].val1); break;
    case LISTDEF: printf("(LISTDEF %d %d)\n", cstack[i].val1, cstack[i].val2); break;
    case LISTA: printf("(LISTA %d %d)\n", cstack[i].val1, cstack[i].val2); break;
    case LISTREF: printf("(LISTREF %d %d)\n", cstack[i].val1, cstack[i].val2); break;
    case RET: printf("(RET %d)\n", cstack[i].val1); break;
    case BREAK: printf("(BREAK %s)\n", namepool+cstack[i].val1); break;
    case REDO: printf("(REDO %s)\n", namepool+cstack[i].val1); break;
    case NEWOBJ: printf("(NEW %d %d)\n", cstack[i].val1, cstack[i].val2); break;
    case INIT: printf("(INIT * *)\n"); break;
    case THIS: printf ("(THIS * *)\n"); break;
    case OBJREF: printf("(OBJREF %d %d)\n", cstack[i].val1, cstack[i].val2); break;
    default: printf ("(*** %d %d)\n", cstack[i].val1, cstack[i].val2);
    }
  }
}
