#include <unistd.h>
#include <stdio.h>
#include <string.h>
#include <setjmp.h>

FILE *yyin;

#define FILELEN 64

int debug = 0;
int optimize = 0;
char fname[FILELEN];

jmp_buf topenv;

main(int ac, char **av)
{
  int r;
  FILE *fp;

  yyin = stdin;
  fname[0] = 0;
  while ((r = getopt(ac, av, "Odf:")) != -1) {
    switch (r) {
    case 'O': optimize = 1; break;
    case 'd': debug = 1; break;
    case 'f': strncpy(fname, optarg, FILELEN);
    }
  }

  yyinit();

  if (fname[0]) {
    if ((fp = fopen(fname, "r")) == NULL) {
      fprintf(stderr, "file %s not found\n", fname);
    } else {
      yyin = fp;
      yyparse();
      yyin = stdin;
    }
  }
  r = setjmp(topenv);

  return yyparse();
}

yyerror(char *msg)
{
  fprintf(stderr, "%s\n", msg);
}

