#include <stdio.h>
#include <setjmp.h>
#include <dlfcn.h>

#define PACKNAMLEN 64
#define MAXHANDLE 4

extern char namepool[];
extern FILE *yyin;
extern int namepooltop;

#define CPREFIX "dc_"
#define CSUFFIX ""

extern jmp_buf topenv;

/* package name is of the form aaa.dc or aaa.so.
aaa.dc is given as a source file of dc.
aaa.so is given as a dynamic library for dc.
*/

void *dlhandle[MAXHANDLE];
int handletop=0;

importfun(int packname)
{
  FILE *fp;
  char pname[PACKNAMLEN];
  char c;

  sprintf(pname, "%s.dc", namepool+packname);
  /*   fprintf(stderr, "importing %s\n", pname); */
  if ((fp = fopen(pname, "r")) != NULL) { 
    /* successful in loading packname.dc */
    FILE *savedin;
    int c;

    savedin = yyin;
    yyin = fp;
    yyparse();
    fclose(fp);
    yyin = savedin;
    longjmp(topenv, 0);
  } else {
    void *handle;

    sprintf(pname, "./%s.so", namepool+packname);
  /*   fprintf(stderr, "importing %s\n", pname); */
    if ((handle = dlopen(pname, RTLD_NOW)) != NULL) {
      dlhandle[handletop++] = handle;
    } else {
      char t[258];

      sprintf(t, "package %s not found (%s)\n", namepool+packname, dlerror());
      yyerror(t);
    } 
  }
}


void *cfunsearch(int varname)
{
  int i;
  char searchname[64], *error;
  void (*handle)();

  sprintf(searchname, "%s%s%s", CPREFIX, namepool+varname, CSUFFIX);
  for (i = handletop-1; i >=0; i--) {
    handle = dlsym(dlhandle[i], searchname);
    if ((error = dlerror()) == NULL) {
      return handle;
    }
  }
  return NULL;
}
