#include <string.h>
extern FILE *yyin;
int listkeywordpos;
int newkeywordpos;
int thiskeywordpos;
int initkeywordpos;

#define NUMKEYWORDS 16

char *keywords[] = {"while", "def", "my", "return", "if", "else", "for", "import", "list", "break", "redo", "new", "class", "val", THISSTR, INITSTR};
int tokenpos[] = {WH, DE, MY, RE, IFIF, ELSE, FOR, IMPORT, LIST, BRK, RDO, NEW, CLASS, VL, THS, OBJINIT};
int keywordpos[NUMKEYWORDS+1];

#define THISPOS 14
#define INITPOS 15

regkeywords()
{
  int i;
  ENTRY e, *r;

  for (i = 0; i < NUMKEYWORDS; i++) {
    strcpy(namepool+namepooltop, keywords[i]);
    e.key = namepool+namepooltop;
    e.data = (void *)namepooltop;
    hsearch_r(e, ENTER, &r, &namhash);
    keywordpos[i] = namepooltop;
    namepooltop += strlen(keywords[i])+1;
  }
  keywordpos[NUMKEYWORDS] = namepooltop;

  e.key = "list";
  hsearch_r(e, FIND, &r, &namhash);
  listkeywordpos = (int)(r->data);

  e.key = "new";
  hsearch_r(e, FIND, &r, &namhash);
  newkeywordpos = (int)(r->data);

  e.key = "this";
  hsearch_r(e, FIND, &r, &namhash);
  thiskeywordpos = (int)(r->data);

  e.key = "init";
  hsearch_r(e, FIND, &r, &namhash);
  initkeywordpos = (int)(r->data);
}

int initpos()
{
  return initkeywordpos;
}

int thispos()
{
  return thiskeywordpos;
}

int newpos()
{
  return newkeywordpos;
}

yylex()
{
	int c;
	int savednamepooltop;

 redo:	c = getc(yyin);
	if (isspace(c)) goto redo;
	if (isdigit(c)) {
	  int r;
	  r = 0;
	  do {
	    r = r *10 + c-'0';
	    c = getc(yyin);
	  } while (isdigit(c));
	  ungetc(c, yyin);
	  yylval = r;
	  return DIGIT;
	} else if (isalpha(c)) {
	  ENTRY e, *r;
	  int i = namepooltop;

	  do {
	    namepool[i++] = c;
	    c = getc(yyin);
	  } while (isalnum(c));
	  ungetc(c, yyin);
	  namepool[i++] = 0;

	  e.key = namepool+namepooltop;
	  hsearch_r(e, FIND, &r, &namhash);
	  if (r == NULL) { 
	    /* not found */
	    e.data = (void *) namepooltop;
	    hsearch_r(e, ENTER, &r, &namhash);
	    yylval = namepooltop;
	    namepooltop = i;

	    return VARIABLE;
	  } else {
	    int j, pos;

	    pos = (int)(r->data);
	    for (j = 0; j < NUMKEYWORDS; j++) {
	      if (pos == keywordpos[j])
		return tokenpos[j];
	    }
	    yylval = pos;
	    return VARIABLE;
	  }
	} else if (c == '>') {
	  c = getchar();
	  if (c == '=') {
	    return GE;
	  } else {
	    ungetc(c, yyin);
	    return GT;
	  }
	} else if (c == '<') { 
	  c = getc(yyin);
	  if (c == '=') {
	    return LE;
	  } else {
	    ungetc(c, yyin);
	    return LT;
	  }
	} else if (c == ':') {
	  c = getc(yyin);
	  if (c == '=') {
	    return ASSIGN;
	  } else {
	    ungetc(c, yyin);
	    return ':';
	  }
	} else if (c == '=') {
	  c = getc(yyin);
	  if (c == '=') {
	    return EQ;
	  } else {
	    ungetc(c, yyin);
	    return ASSIGN;
	  }
	} else if (c=='!') {
	  c = getc(yyin);
	  if (c == '=') {
	    return NE;
	  } else {
	    ungetc(c, yyin);
	    return NOT;
	  } 
	}
	return c;
}


