#include "ptopcode.h"
#include "vcc.h"
#include "vm.h"

#define RTL_NOP 0
#define RTL_MOV 1
#define RTL_PUSHARG 2
#define RTL_CALL 3

#define RTL_NOT 5
#define RTL_ADD 6
#define RTL_SUB 7
#define RTL_MUL 8
#define RTL_DIV 9
#define RTL_GREATEREQ 10
#define RTL_GREATER 11
#define RTL_LESS 12
#define RTL_LESSEQ 13
#define RTL_EQUAL 14
#define RTL_NOTEQUAL 15
#define RTL_IF 16
#define RTL_WHILE 17
#define RTL_RETURN 18

typedef struct _rtl_t {
  int opcode;
  int op[3];
  int next;
  int prev;
} rtl_t;


#define RTL_CONST 0
#define RTL_REG   1
#define RTL_NAME  2
#define RTL_ADDRESS 3

#define REGCONST    ((RTL_REG<<2)|RTL_CONST)
#define REGREG      ((RTL_REG<<2)|RTL_REG)
#define REGNAME     ((RTL_REG<<2)|RTL_NAME)
#define REGADDRESS  ((RTL_REG<<2)|RTL_ADDRESS)
#define NAMEREG     ((RTL_NAME<<2)|RTL_REG)
#define ADDRESSREG  ((RTL_ADDRESS<<2)|RTL_REG)

#define nthkind(mv, n) (3 & ((mv) >> ((n)*2)))
#define isconst(mv, op) ((nthkind(mv, op)) == RTL_CONST)
#define isreg(mv, op) ((nthkind(mv, op)) == RTL_REG)
#define isname(mv, op) ((nthkind(mv, op)) == RTL_NAME)
#define isaddress(mv, op) ((nthkind(mv, op)) == RTL_ADDRESS)
/*
#define isconst(mv, op) ((3 & ((mv) >> ((op)*2))) == RTL_CONST)
#define isreg(mv, op) ((3 & ((mv) >> ((op)*2))) == RTL_REG)
#define isname(mv, op) ((3 & ((mv) >> ((op)*2))) == RTL_NAME)
#define isaddress(mv, op) ((3 & ((mv) >> ((op)*2))) == RTL_ADDRESS)
*/

extern rtl_t rtlstack[];
extern int rtlstacktop;

extern int lvarstack[];
extern int lvarp;




