#ifndef VM_H
#define VM_H

#if !defined(__USE_GNU)
#define __USE_GNU
#endif
#define _GNU_SOURCE
#include <stdlib.h>
#include <stdio.h>
#include <search.h>



#define VAL 0
#define FUN 1
#define CFUN 2
#define LST 3
#define CLS 4

typedef struct _codeseg {
  int op;
  int operand;
} t_codeseg;

typedef struct _dataseg {
  int typ;
  void *val;
  int paramlen;
} t_dataseg;

typedef int t_stackseg;

extern t_dataseg objectab[];

extern t_codeseg codeseg[];
extern t_stackseg stackseg[];
extern int dataseg[];

extern int codepc;
extern int stacktop;
extern int dsegtop;

extern char namepool[];
extern struct hsearch_data namhash;
extern struct hsearch_data objtabhash;

/*
format of class 
           +------------+
method[0]  | kind       |
           +------------+
	   | method name|
	   +------------+
	   | method body|
	   +------------+
	   | paramlen   |
	   +------------+
	   | result kind|
	   +------------+
method[1]  | kind       |
           +------------+
	     ...
...

method[n] 

 */

#define methentrysize (5)
#define methkind(base, i) (dataseg[(int)(base)+methentrysize*(i)])
#define methname(base, i) (dataseg[(int)(base)+methentrysize*(i)+1])
#define methbody(base, i) (dataseg[(int)(base)+methentrysize*(i)+2])
#define methparamlen(base, i) (dataseg[(int)(base)+methentrysize*(i)+3])
#define methresk(base, i) (dataseg[(int)(base)+methentrysize*(i)+4])

/* format of object -- 
      +----------+
      | classname|
      +----------+
      | method[0]|
      +----------+
      ...
      +----------+
      | method[n]|
      +----------+
just a list of methods*/
 
#define objname(obj)  (dataseg[obj])
#define objmethod(obj, i) (dataseg[obj+i+1])
#endif

